Attribute VB_Name = "VideoModeModule"
' ,  
'   
Declare Function GetDeviceCaps Lib "gdi32.dll" _
(ByVal DC As Long, ByVal Index As Long) As Long

Declare Function GetDesktopWindow Lib "user32.dll" _
() As Long

Declare Function GetDC Lib "user32.dll" _
(ByVal hwnd As Long) As Long

Declare Function ReleaseDC Lib "user32.dll" _
(ByVal hwnd As Long, ByVal DC As Long) As Long

'    
'
Private Declare Function ChangeDisplaySettings _
Lib "user32.dll" Alias "ChangeDisplaySettingsA" _
(ScreenMode As ScreenModeProperties, ByVal Falgs _
As Long) As Long

'     ,
'    
'    
Const CCHDEVICENAME = 32
Const CCHFORMNAME = 32
Const DM_BITSPERPEL = &H40000
Const DM_PELSWIDTH = &H80000
Const DM_PELSHEIGHT = &H100000

Private Type ScreenModeProperties
  DeviceName As String * CCHDEVICENAME
  SpecVersion As Integer
  DriverVersion As Integer
  Size As Integer
  DriverExtra As Integer
  Fields As Long
  Orientation As Integer
  PaperSize As Integer
  PaperLength As Integer
  PaperWidth As Integer
  Scale As Integer
  Copies As Integer
  DefaultSource As Integer
  PrintQuality As Integer
  Color As Integer
  Duplex As Integer
  YResolution As Integer
  TTOption As Integer
  Collate As Integer
  FormName As String * CCHFORMNAME
  UnusedPadding As Integer
  BitsPerPel As Integer
  PelsWidth As Long
  PelsHeight As Long
  DisplayFlags As Long
  DisplayFrequency As Long
End Type

Function SetNewScreenMode(NewScreenWidth As Long, NewScreenHeight As Long, NewScreenDepth As Long)
On Error Resume Next
Dim NewScreenMode As ScreenModeProperties
NewScreenMode.PelsWidth = NewScreenWidth
NewScreenMode.PelsHeight = NewScreenHeight
NewScreenMode.BitsPerPel = NewScreenDepth
NewScreenMode.Size = Len(NewScreenMode)
NewScreenMode.Fields = DM_PELSWIDTH + DM_PELSHEIGHT + DM_BITSPERPEL
ChangeDisplaySettings NewScreenMode, 0
End Function

Public Function GetVideoMode() As String
'  
On Error Resume Next
Dim ScreenWidth As Long
Dim ScreenHeight As Long
Dim ScreenDepth As Long
Dim DC As Long
DC = GetDC(GetDesktopWindow())
'
ScreenWidth = GetDeviceCaps(DC, 8)
'
ScreenHeight = GetDeviceCaps(DC, 10)
' 
ScreenDepth = GetDeviceCaps(DC, 12)
ReleaseDC GetDesktopWindow(), DC

GetVideoMode = ScreenWidth & "_" & ScreenHeight & "_" & ScreenDepth
End Function
