VERSION 5.00
Begin VB.UserControl WinDesk 
   ClientHeight    =   750
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1020
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   50
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   68
   ToolboxBitmap   =   "WinDesk.ctx":0000
   Begin VB.Timer Timer1 
      Interval        =   10
      Left            =   600
      Top             =   0
   End
   Begin VB.PictureBox Icon 
      Height          =   540
      Left            =   0
      Picture         =   "WinDesk.ctx":00F0
      ScaleHeight     =   32
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   32
      TabIndex        =   0
      Top             =   0
      Width           =   540
   End
End
Attribute VB_Name = "WinDesk"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'    
Option Explicit

'    
'Windows (   -  )
Private Declare Function SystemParametersInfo _
Lib "user32.dll" Alias "SystemParametersInfoA" _
(ByVal uAction As Long, ByVal uParam As Long, _
lpvParam As Any, ByVal fuWinIni As Long) As Long

'   
Event ScreenResolutionChanged(X As Integer, Y As Integer, Bits As Integer)

'    
Dim LastRes As String
Sub About()
On Error GoTo BackColorPropGet_Err
MsgBox "WinDesktop ActiveX .  " & App.Major & "." & Format(App.Minor, "00") & "." & Format(App.Revision, "0000"), 64, " "
Exit Sub

' :
BackColorPropGet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "   "" "".", 48, App.Title

End Sub
Private Sub Timer1_Timer()
If LastRes <> Resolution Then
    LastRes = Resolution
    
    Dim ResX As String
    Dim ResY As String
    Dim ResBits As String
    Dim Temp As String
    '   LastRes
    '3    
    ResX = Left(LastRes, InStr(LastRes, "_") - 1)
    Temp = Right(LastRes, Len(LastRes) - Len(ResX) - 1)
    ResY = Left(Temp, InStr(Temp, "_") - 1)
    ResBits = Right(LastRes, Len(LastRes) - Len(ResX) - Len(ResY) - 2)
    '  
    
    RaiseEvent ScreenResolutionChanged(Val(ResX), Val(ResY), Val(ResBits))
End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'   ,  
'  
DoEvents
End Sub

Private Sub UserControl_Resize()
'    
',   ,
'  
On Error GoTo Resize_Err
UserControl.Width = Icon.Width * 15
UserControl.Height = Icon.Height * 15
Exit Sub

'   
Resize_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "    .", 48, App.Title
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
'   ,  
'  
DoEvents
End Sub

Public Property Get WallPaper() As String
Attribute WallPaper.VB_MemberFlags = "40"
'  .
DoEvents
End Property

Public Property Let WallPaper(ByVal WallpaperFile As String)
' 
On Error GoTo DarkColorPropLet_Err
'  
SystemParametersInfo 20, 0, ByVal WallpaperFile, True
PropertyChanged WallPaper
Exit Property

' :
DarkColorPropLet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "       .", 48, App.Title
End Property
Public Property Get ()
Attribute .VB_ProcData.VB_Invoke_Property = "Information"
Attribute .VB_MemberFlags = "40"
'  .  
'  
DoEvents
 = "  "
End Property

Public Property Let (OtherValue As Variant)
'   , , 
',    
DoEvents
End Property

Public Property Get Resolution() As String
Attribute Resolution.VB_MemberFlags = "440"
' 
Resolution = GetVideoMode
End Property

Public Property Let Resolution(ByVal NewResolution As String)
' 
On Error GoTo ResLet_Err
Dim ResX As String
Dim ResY As String
Dim ResBits As String
Dim Temp As String
'   NewResolution
'3    
ResX = Left(NewResolution, InStr(NewResolution, "_") - 1)
Temp = Right(NewResolution, Len(NewResolution) - Len(ResX) - 1)
ResY = Left(Temp, InStr(Temp, "_") - 1)
ResBits = Right(NewResolution, Len(NewResolution) - Len(ResX) - Len(ResY) - 2)
'  
SetNewScreenMode Val(ResX), Val(ResY), Val(ResBits)

PropertyChanged Resolution
RaiseEvent ScreenResolutionChanged(Val(ResX), Val(ResY), Val(ResBits))
Exit Property

' :
ResLet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "     .", 48, App.Title
End Property
